"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var utilResponsive_1 = require("./utilResponsive");
var IdDevice_1 = require("./IdDevice");
var IdDeviceBreakpoints_1 = require("./IdDeviceBreakpoints");
var windowDimensionSubject = new rxjs_1.Subject();
exports.windowDimensionSubs = windowDimensionSubject.pipe(operators_1.share());
var ResponsiveWatcher = /** @class */ (function (_super) {
    __extends(ResponsiveWatcher, _super);
    function ResponsiveWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.render = function () {
            return null;
        };
        _this.updateDimensions = function () {
            var windowDimensionMetrics = utilResponsive_1.utilResponsive.getWindowDimensions();
            _this.setState(windowDimensionMetrics);
            windowDimensionSubject.next(windowDimensionMetrics);
        };
        _this.componentWillMount = function () {
            _this.updateDimensions();
        };
        _this.componentDidMount = function () {
            window.addEventListener('resize', _this.updateDimensions);
        };
        _this.componentWillUnmount = function () {
            window.removeEventListener('resize', _this.updateDimensions);
        };
        return _this;
    }
    return ResponsiveWatcher;
}(React.PureComponent));
exports.ResponsiveWatcher = ResponsiveWatcher;
exports.DeviceWidthObject = (_a = {},
    _a[IdDevice_1.IdDeviceTypeBreakdown.MobileSmall] = { max: 320, min: 0 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.MobileMedium] = { max: 375, min: 321 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.MobileLarge] = { max: 767, min: 376 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.Tablet] = { max: 991, min: 768 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.LaptopSmall] = { max: 1024, min: 992 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.LaptopLarge] = { max: 1440, min: 1025 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.LargerThanLaptop] = { max: 2560, min: 1441 },
    _a[IdDevice_1.IdDeviceTypeBreakdown.LargeScreenMax] = { max: 999999, min: 2561 },
    _a);
exports.getDeviceTypeInfo = function () {
    var _a = utilResponsive_1.utilResponsive.getWindowDimensions(), width = _a.width, height = _a.height;
    var buildDeviceDetails = {
        deviceType: '',
        deviceTypeVariant: '',
        orientation: IdDevice_1.IdDeviceOrientation.Portrait,
        width: width,
        height: height
    };
    if (height < width) {
        // Orientation is landscape
        buildDeviceDetails.orientation = IdDevice_1.IdDeviceOrientation.Landscape;
        if (height <= IdDeviceBreakpoints_1.IdMobileHeight.mobileLandscape_max) {
            // Mobile (landscape)
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Mobile;
            for (var devc in exports.DeviceWidthObject) {
                if (height <= exports.DeviceWidthObject[devc].max && height >= exports.DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
        else if (width <= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.tablet_max && width >= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.tablet_min) {
            // Tablet (landscape)
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Tablet;
            buildDeviceDetails.deviceTypeVariant = IdDevice_1.IdDeviceTypeBreakdown.Tablet;
        }
        else if (width <= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.laptop_max && width >= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.laptop_min) {
            // Laptop (landscape)
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Laptop;
            for (var devc in exports.DeviceWidthObject) {
                if (width <= exports.DeviceWidthObject[devc].max && width >= exports.DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
        else {
            // Larger than Laptop (landscape)
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.LargerThanLaptop;
            for (var devc in exports.DeviceWidthObject) {
                if (width <= exports.DeviceWidthObject[devc].max && width >= exports.DeviceWidthObject[devc].min) {
                    buildDeviceDetails.deviceTypeVariant = devc;
                    break;
                }
            }
        }
    }
    else {
        // Orientation is portrait
        buildDeviceDetails.orientation = IdDevice_1.IdDeviceOrientation.Portrait;
        for (var devc in exports.DeviceWidthObject) {
            if (width <= exports.DeviceWidthObject[devc].max && width >= exports.DeviceWidthObject[devc].min) {
                buildDeviceDetails.deviceTypeVariant = devc;
                break;
            }
        }
        if (width <= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.laptop_max && width >= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.laptop_min) {
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Laptop;
        }
        if (width <= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.tablet_max && width >= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.tablet_min) {
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Tablet;
        }
        if (width <= IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.mobile_max) {
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.Mobile;
        }
        if (width > IdDeviceBreakpoints_1.IdDeviceBreakpointsByWidth.laptop_max) {
            buildDeviceDetails.deviceType = IdDevice_1.IdDeviceType.LargerThanLaptop;
        }
    }
    return buildDeviceDetails;
};
var _a;
